<script setup lang="ts">
import {ref, watch} from 'vue';
import type {TCertificateIdentifier} from '@/types';
import type {TCertificatesMap} from '@/provider/BrowserPlugin'; // fixme --> types

const model = defineModel<TCertificatesMap>({default: new Map});
// fixme: кнопки внизу надо куда то убрать в другой компонент
// const canSignRef = ref(false);
const selectedCertificateRef = ref<TCertificateIdentifier | null>(null);

watch(selectedCertificateRef, (value: TCertificateIdentifier | null) => {
  console.log('selected: ', value);
  emit('changed', selectedCertificateRef.value);
})

const emit = defineEmits<{
  (e: 'changed', thumbprint: TCertificateIdentifier | null): void
  (e: 'confirmed', thumbprint: TCertificateIdentifier): void
}>();

</script>

<template>
  <CdsContainer>
    <CdsContainerItem>
      <h4 class="cds-mb-m">Выбрать сертификат</h4>
      <CdsContainer
          v-model="selectedCertificateRef"
          required
          direction="vertical"
          appearance="secondary"
          prepend-icon="administrator">
        <CdsContainerItem
            v-for="certificate in model.values()"
            :key="certificate.thumbprint"
            :value="certificate.thumbprint"
            group="radio"
            type="selectable"
            label="Группа контейнеров"
        >
          <h6 class="cds-mt-none cds-mb-xxs">
            {{ certificate.thumbprint }}
          </h6>
          <span class="cds-font-body-size-xs">{{ certificate.getName() }}</span>
        </CdsContainerItem>
      </CdsContainer>
    </CdsContainerItem>
  </CdsContainer>
  <CdsContainer class="cds-flex cds-justify-center cds-mt-no cds-mb-m">
        <CdsContainerItem>
<!--          <CdsButton appearance="secondary">-->
<!--            Закрыть-->
<!--          </CdsButton>-->
          <CdsButton appearance="primary" @click="emit('confirmed', selectedCertificateRef ?? '')" :disabled="selectedCertificateRef === null">
            Подписать
          </CdsButton>
        </CdsContainerItem>
  </CdsContainer>
</template>